Index: keys.cpp
===================================================================
--- keys.cpp	(revision 3442)
+++ keys.cpp	(working copy)
@@ -139,6 +139,16 @@
 	return 1;
 }
 
+#if 0 // TODO: [SDL2]: obsolete keys... use scancode ?
+SDLK_KP0;SDLK_KP1;SDLK_KP2;SDLK_KP3;SDLK_KP4;
+SDLK_KP5;SDLK_KP6;SDLK_KP7;SDLK_KP8;SDLK_KP9;
+SDLK_NUMLOCK;SDLK_SCROLLOCK;
+SDLK_RMETA;SDLK_LMETA;
+SDLK_LSUPER;SDLK_RSUPER;
+SDLK_COMPOSE;SDLK_PRINT;SDLK_BREAK;SDLK_EURO;
+#endif
+
+
 // Liefert einen String mit dem Namen der Taste zurueck:
 const char* GetKeyString (SDLKey key)
 {
@@ -216,16 +226,6 @@
 		case SDLK_y: return "Y";
 		case SDLK_z: return "Z";
 		case SDLK_DELETE: return "DELETE";
-		case SDLK_KP0: return "KP0";
-		case SDLK_KP1: return "KP1";
-		case SDLK_KP2: return "KP2";
-		case SDLK_KP3: return "KP3";
-		case SDLK_KP4: return "KP4";
-		case SDLK_KP5: return "KP5";
-		case SDLK_KP6: return "KP6";
-		case SDLK_KP7: return "KP7";
-		case SDLK_KP8: return "KP8";
-		case SDLK_KP9: return "KP9";
 		case SDLK_KP_PERIOD: return "KP_PERIOD";
 		case SDLK_KP_DIVIDE: return "KP_DIVIDE";
 		case SDLK_KP_MULTIPLY: return "KP_MULTIPLY";
@@ -257,9 +257,7 @@
 		case SDLK_F13: return "F13";
 		case SDLK_F14: return "F14";
 		case SDLK_F15: return "F15";
-		case SDLK_NUMLOCK: return "NUMLOCK";
 		case SDLK_CAPSLOCK: return "CAPSLOCK";
-		case SDLK_SCROLLOCK: return "SCROLLOCK";
 		case SDLK_RSHIFT: return "RSHIFT";
 		case SDLK_LSHIFT: return "LSHIFT";
 		case SDLK_RCTRL: return "RCTRL";
@@ -266,19 +264,11 @@
 		case SDLK_LCTRL: return "LCTRL";
 		case SDLK_RALT: return "RALT";
 		case SDLK_LALT: return "LALT";
-		case SDLK_RMETA: return "RMETA";
-		case SDLK_LMETA: return "LMETA";
-		case SDLK_LSUPER: return "LSUPER";
-		case SDLK_RSUPER: return "RSUPER";
 		case SDLK_MODE: return "MODE";
-		case SDLK_COMPOSE: return "COMPOSE";
 		case SDLK_HELP: return "HELP";
-		case SDLK_PRINT: return "PRINT";
 		case SDLK_SYSREQ: return "SYSREQ";
-		case SDLK_BREAK: return "BREAK";
 		case SDLK_MENU: return "MENU";
 		case SDLK_POWER: return "POWER";
-		case SDLK_EURO: return "EURO";
 		case SDLK_UNDO: return "UNDO";
 		default: return "?";
 	}
@@ -359,16 +349,6 @@
 	if (!key.compare ("Y")) return SDLK_y;
 	if (!key.compare ("Z")) return SDLK_z;
 	if (!key.compare ("DELETE")) return SDLK_DELETE;
-	if (!key.compare ("KP0")) return SDLK_KP0;
-	if (!key.compare ("KP1")) return SDLK_KP1;
-	if (!key.compare ("KP2")) return SDLK_KP2;
-	if (!key.compare ("KP3")) return SDLK_KP3;
-	if (!key.compare ("KP4")) return SDLK_KP4;
-	if (!key.compare ("KP5")) return SDLK_KP5;
-	if (!key.compare ("KP6")) return SDLK_KP6;
-	if (!key.compare ("KP7")) return SDLK_KP7;
-	if (!key.compare ("KP8")) return SDLK_KP8;
-	if (!key.compare ("KP9")) return SDLK_KP9;
 	if (!key.compare ("KP_PERIOD")) return SDLK_KP_PERIOD;
 	if (!key.compare ("KP_DIVIDE")) return SDLK_KP_DIVIDE;
 	if (!key.compare ("KP_MULTIPLY")) return SDLK_KP_MULTIPLY;
@@ -400,9 +380,7 @@
 	if (!key.compare ("F13")) return SDLK_F13;
 	if (!key.compare ("F14")) return SDLK_F14;
 	if (!key.compare ("F15")) return SDLK_F15;
-	if (!key.compare ("NUMLOCK")) return SDLK_NUMLOCK;
 	if (!key.compare ("CAPSLOCK")) return SDLK_CAPSLOCK;
-	if (!key.compare ("SCROLLOCK")) return SDLK_SCROLLOCK;
 	if (!key.compare ("RSHIFT")) return SDLK_RSHIFT;
 	if (!key.compare ("LSHIFT")) return SDLK_LSHIFT;
 	if (!key.compare ("RCTRL")) return SDLK_RCTRL;
@@ -409,19 +387,11 @@
 	if (!key.compare ("LCTRL")) return SDLK_LCTRL;
 	if (!key.compare ("RALT")) return SDLK_RALT;
 	if (!key.compare ("LALT")) return SDLK_LALT;
-	if (!key.compare ("RMETA")) return SDLK_RMETA;
-	if (!key.compare ("LMETA")) return SDLK_LMETA;
-	if (!key.compare ("LSUPER")) return SDLK_LSUPER;
-	if (!key.compare ("RSUPER")) return SDLK_RSUPER;
 	if (!key.compare ("MODE")) return SDLK_MODE;
-	if (!key.compare ("COMPOSE")) return SDLK_COMPOSE;
 	if (!key.compare ("HELP")) return SDLK_HELP;
-	if (!key.compare ("PRINT")) return SDLK_PRINT;
 	if (!key.compare ("SYSREQ")) return SDLK_SYSREQ;
-	if (!key.compare ("BREAK")) return SDLK_BREAK;
 	if (!key.compare ("MENU")) return SDLK_MENU;
 	if (!key.compare ("POWER")) return SDLK_POWER;
-	if (!key.compare ("EURO")) return SDLK_EURO;
 	if (!key.compare ("UNDO")) return SDLK_UNDO;
 	return SDLK_UNKNOWN;
 }
Index: keys.h
===================================================================
--- keys.h	(revision 3442)
+++ keys.h	(working copy)
@@ -22,6 +22,10 @@
 #include <string>
 #include "defines.h"
 
+#if 1 // TODO [SDL2]: use scancode or keycode ?
+typedef SDL_Keycode SDLKey;
+#endif
+
 // Globale Daten /////////////////////////////////////////////////////////////
 class cKeysList
 {
Index: loaddata.cpp
===================================================================
--- loaddata.cpp	(revision 3442)
+++ loaddata.cpp	(working copy)
@@ -357,12 +357,12 @@
 			if (pos == 0)   //need full line for first entry version information
 			{
 				SDL_BlitSurface (buffer, NULL, screen, NULL);
-				SDL_UpdateRect (screen, rDest.x, rDest.y + rDest.h * pos, rDest.w + rDest2.w, rDest.h);
+				Video.draw();
 			}
 			else
 			{
 				SDL_BlitSurface (buffer, &rSrc, screen, &rSrc);
-				SDL_UpdateRect (screen, rDest.x, rDest.y + rDest.h * pos, rDest.w, rDest.h);
+				Video.draw();
 			}
 			break;
 
@@ -380,7 +380,7 @@
 		rSrc = rDest2;
 		rSrc.y = rDest2.y + rDest2.h * pos;
 		SDL_BlitSurface (buffer, &rSrc, screen, &rSrc);
-		SDL_UpdateRect (screen, rDest2.x, rDest2.y + rDest2.h * pos, rDest2.w, rDest2.h);
+		Video.draw();
 	}
 }
 
@@ -474,8 +474,8 @@
 
 	dest[0] = LoadPCX (filepath);
 	dest[1] = CloneSDLSurface (dest[0]);
-	SDL_SetAlpha (dest[0], SDL_SRCALPHA, alpha);
-	SDL_SetAlpha (dest[1], SDL_SRCALPHA, alpha);
+	SDL_SetSurfaceAlphaMod (dest[0], alpha);
+	SDL_SetSurfaceAlphaMod (dest[1], alpha);
 
 	filepath.insert (0, "Effectalpha loaded: ");
 	Log.write (filepath.c_str(), LOG_TYPE_DEBUG);
@@ -607,7 +607,7 @@
 	LoadEffectGraphicToSurface (fx_rocket, path, "rocket.pcx");
 	LoadEffectAlphaToSurface (fx_dark_smoke, path, "dark_smoke.pcx", 100);
 	LoadEffectAlphaToSurface (fx_tracks, path, "tracks.pcx", 100);
-	LoadEffectAlphaToSurface (fx_corpse, path, "corpse.pcx", 255);
+	LoadEffectAlphaToSurface (fx_corpse, path, "corpse.pcx", 254);
 	LoadEffectAlphaToSurface (fx_absorb, path, "absorb.pcx", 150);
 }
 
@@ -855,17 +855,17 @@
 
 	Log.write ("Shadowgraphics...", LOG_TYPE_DEBUG);
 	// Shadow:
-	GraphicsData.gfx_shadow = SDL_CreateRGBSurface (Video.getSurfaceType(), Video.getResolutionX(),
-													Video.getResolutionY(), Video.getColDepth(), 0, 0, 0, 0);
+	GraphicsData.gfx_shadow = SDL_CreateRGBSurface (0, Video.getResolutionX(), Video.getResolutionY(),
+													Video.getColDepth(), 0, 0, 0, 0);
 	SDL_FillRect (GraphicsData.gfx_shadow, NULL, 0x0);
-	SDL_SetAlpha (GraphicsData.gfx_shadow, SDL_SRCALPHA, 50);
-	GraphicsData.gfx_tmp = SDL_CreateRGBSurface (Video.getSurfaceType(), 128, 128, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (GraphicsData.gfx_tmp, SDL_SRCCOLORKEY, 0xFF00FF);
+	SDL_SetSurfaceAlphaMod (GraphicsData.gfx_shadow, 50);
+	GraphicsData.gfx_tmp = SDL_CreateRGBSurface (0, 128, 128, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (GraphicsData.gfx_tmp, SDL_TRUE, 0xFF00FF);
 
 	// Glas:
 	Log.write ("Glassgraphic...", LOG_TYPE_DEBUG);
 	LoadGraphicToSurface (GraphicsData.gfx_destruction_glas, path, "destruction_glas.pcx");
-	SDL_SetAlpha (GraphicsData.gfx_destruction_glas, SDL_SRCALPHA, 150);
+	SDL_SetSurfaceAlphaMod (GraphicsData.gfx_destruction_glas, 150);
 
 	// Waypoints:
 	Log.write ("Waypointgraphics...", LOG_TYPE_DEBUG);
@@ -922,7 +922,7 @@
 	if (LoadGraphicToSurface (res_metal_org, path, "res.pcx") == 1)
 	{
 		res_metal = CloneSDLSurface (res_metal_org);
-		SDL_SetColorKey (res_metal, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (res_metal, SDL_TRUE, 0xFF00FF);
 	}
 
 	// gold
@@ -929,7 +929,7 @@
 	if (LoadGraphicToSurface (res_gold_org, path, "gold.pcx") == 1)
 	{
 		res_gold = CloneSDLSurface (res_gold_org);
-		SDL_SetColorKey (res_gold, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (res_gold, SDL_TRUE, 0xFF00FF);
 	}
 
 	// fuel
@@ -936,7 +936,7 @@
 	if (LoadGraphicToSurface (res_oil_org, path, "fuel.pcx") == 1)
 	{
 		res_oil = CloneSDLSurface (res_oil_org);
-		SDL_SetColorKey (res_oil, SDL_SRCCOLORKEY, 0xFF00FF);
+		SDL_SetColorKey (res_oil, SDL_TRUE, 0xFF00FF);
 	}
 }
 
@@ -1040,8 +1040,8 @@
 			SDL_Rect rcDest;
 			for (int n = 0; n < 8; n++)
 			{
-				ui.img[n] = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
-				SDL_SetColorKey (ui.img[n], SDL_SRCCOLORKEY, 0x00FFFFFF);
+				ui.img[n] = SDL_CreateRGBSurface (0, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
+				SDL_SetColorKey (ui.img[n], SDL_TRUE, 0x00FFFFFF);
 				SDL_FillRect (ui.img[n], NULL, 0x00FF00FF);
 
 				for (int j = 0; j < 13; j++)
@@ -1066,16 +1066,16 @@
 						}
 					}
 				}
-				ui.img_org[n] = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
-				SDL_SetColorKey (ui.img[n], SDL_SRCCOLORKEY, 0x00FFFFFF);
+				ui.img_org[n] = SDL_CreateRGBSurface (0, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
+				SDL_SetColorKey (ui.img[n], SDL_TRUE, 0x00FFFFFF);
 				SDL_FillRect (ui.img_org[n], NULL, 0x00FFFFFF);
 				SDL_BlitSurface (ui.img[n], NULL, ui.img_org[n], NULL);
 
-				ui.shw[n] = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
-				SDL_SetColorKey (ui.shw[n], SDL_SRCCOLORKEY, 0x00FF00FF);
+				ui.shw[n] = SDL_CreateRGBSurface (0, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
+				SDL_SetColorKey (ui.shw[n], SDL_TRUE, 0x00FF00FF);
 				SDL_FillRect (ui.shw[n], NULL, 0x00FF00FF);
-				ui.shw_org[n] = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
-				SDL_SetColorKey (ui.shw_org[n], SDL_SRCCOLORKEY, 0x00FF00FF);
+				ui.shw_org[n] = SDL_CreateRGBSurface (0, 64 * 13, 64, Video.getColDepth(), 0, 0, 0, 0);
+				SDL_SetColorKey (ui.shw_org[n], SDL_TRUE, 0x00FF00FF);
 				SDL_FillRect (ui.shw_org[n], NULL, 0x00FF00FF);
 
 				rcDest.x = 3;
@@ -1091,8 +1091,8 @@
 				}
 				SDL_UnlockSurface (ui.shw_org[n]);
 				SDL_BlitSurface (ui.shw_org[n], NULL, ui.shw[n], NULL);
-				SDL_SetAlpha (ui.shw_org[n], SDL_SRCALPHA, 50);
-				SDL_SetAlpha (ui.shw[n], SDL_SRCALPHA, 50);
+				SDL_SetSurfaceAlphaMod (ui.shw_org[n], 50);
+				SDL_SetSurfaceAlphaMod (ui.shw[n], 50);
 			}
 		}
 		// load other vehicle graphics
@@ -1110,8 +1110,8 @@
 				{
 					ui.img_org[n] = LoadPCX (sTmpString);
 					ui.img[n] = CloneSDLSurface (ui.img_org[n]);
-					SDL_SetColorKey (ui.img_org[n], SDL_SRCCOLORKEY, 0xFFFFFF);
-					SDL_SetColorKey (ui.img[n], SDL_SRCCOLORKEY, 0xFFFFFF);
+					SDL_SetColorKey (ui.img_org[n], SDL_TRUE, 0xFFFFFF);
+					SDL_SetColorKey (ui.img[n], SDL_TRUE, 0xFFFFFF);
 				}
 				else
 				{
@@ -1125,7 +1125,7 @@
 				{
 					ui.shw_org[n] = LoadPCX (sTmpString);
 					ui.shw[n] = CloneSDLSurface (ui.shw_org[n]);
-					SDL_SetAlpha (ui.shw[n], SDL_SRCALPHA, 50);
+					SDL_SetSurfaceAlphaMod (ui.shw[n], 50);
 				}
 				else
 				{
@@ -1210,8 +1210,8 @@
 			{
 				ui.build_org = LoadPCX (sTmpString);
 				ui.build = CloneSDLSurface (ui.build_org);
-				SDL_SetColorKey (ui.build_org, SDL_SRCCOLORKEY, 0xFFFFFF);
-				SDL_SetColorKey (ui.build, SDL_SRCCOLORKEY, 0xFFFFFF);
+				SDL_SetColorKey (ui.build_org, SDL_TRUE, 0xFFFFFF);
+				SDL_SetColorKey (ui.build, SDL_TRUE, 0xFFFFFF);
 			}
 			else
 			{
@@ -1227,7 +1227,7 @@
 			{
 				ui.build_shw_org = LoadPCX (sTmpString);
 				ui.build_shw = CloneSDLSurface (ui.build_shw_org);
-				SDL_SetAlpha (ui.build_shw, SDL_SRCALPHA, 50);
+				SDL_SetSurfaceAlphaMod (ui.build_shw, 50);
 			}
 			else
 			{
@@ -1255,8 +1255,8 @@
 			{
 				ui.clear_small_org = LoadPCX (sTmpString);
 				ui.clear_small = CloneSDLSurface (ui.clear_small_org);
-				SDL_SetColorKey (ui.clear_small_org, SDL_SRCCOLORKEY, 0xFFFFFF);
-				SDL_SetColorKey (ui.clear_small, SDL_SRCCOLORKEY, 0xFFFFFF);
+				SDL_SetColorKey (ui.clear_small_org, SDL_TRUE, 0xFFFFFF);
+				SDL_SetColorKey (ui.clear_small, SDL_TRUE, 0xFFFFFF);
 			}
 			else
 			{
@@ -1272,7 +1272,7 @@
 			{
 				ui.clear_small_shw_org = LoadPCX (sTmpString);
 				ui.clear_small_shw = CloneSDLSurface (ui.clear_small_shw_org);
-				SDL_SetAlpha (ui.clear_small_shw, SDL_SRCALPHA, 50);
+				SDL_SetSurfaceAlphaMod (ui.clear_small_shw, 50);
 			}
 			else
 			{
@@ -1288,8 +1288,8 @@
 			{
 				ui.build_org = LoadPCX (sTmpString);
 				ui.build = CloneSDLSurface (ui.build_org);
-				SDL_SetColorKey (ui.build_org, SDL_SRCCOLORKEY, 0xFFFFFF);
-				SDL_SetColorKey (ui.build, SDL_SRCCOLORKEY, 0xFFFFFF);
+				SDL_SetColorKey (ui.build_org, SDL_TRUE, 0xFFFFFF);
+				SDL_SetColorKey (ui.build, SDL_TRUE, 0xFFFFFF);
 			}
 			else
 			{
@@ -1305,7 +1305,7 @@
 			{
 				ui.build_shw_org = LoadPCX (sTmpString);
 				ui.build_shw = CloneSDLSurface (ui.build_shw_org);
-				SDL_SetAlpha (ui.build_shw, SDL_SRCALPHA, 50);
+				SDL_SetSurfaceAlphaMod (ui.build_shw, 50);
 			}
 			else
 			{
@@ -1594,8 +1594,8 @@
 		{
 			ui.img_org = LoadPCX (sTmpString);
 			ui.img = CloneSDLSurface (ui.img_org);
-			SDL_SetColorKey (ui.img_org, SDL_SRCCOLORKEY, 0xFFFFFF);
-			SDL_SetColorKey (ui.img, SDL_SRCCOLORKEY, 0xFFFFFF);
+			SDL_SetColorKey (ui.img_org, SDL_TRUE, 0xFFFFFF);
+			SDL_SetColorKey (ui.img, SDL_TRUE, 0xFFFFFF);
 		}
 		else
 		{
@@ -1609,7 +1609,7 @@
 		{
 			ui.shw_org = LoadPCX (sTmpString);
 			ui.shw     = CloneSDLSurface (ui.shw_org);
-			SDL_SetAlpha (ui.shw, SDL_SRCALPHA, 50);
+			SDL_SetSurfaceAlphaMod (ui.shw, 50);
 		}
 
 		// load video
@@ -1633,7 +1633,7 @@
 			{
 				ui.eff_org = LoadPCX (sTmpString);
 				ui.eff = CloneSDLSurface (ui.eff_org);
-				SDL_SetAlpha (ui.eff, SDL_SRCALPHA, 10);
+				SDL_SetSurfaceAlphaMod (ui.eff, 10);
 			}
 		}
 		else
@@ -1655,16 +1655,16 @@
 			b.isConnectorGraphic = true;
 			UnitsData.ptr_connector = ui.img;
 			UnitsData.ptr_connector_org = ui.img_org;
-			SDL_SetColorKey (UnitsData.ptr_connector, SDL_SRCCOLORKEY, 0xFF00FF);
+			SDL_SetColorKey (UnitsData.ptr_connector, SDL_TRUE, 0xFF00FF);
 			UnitsData.ptr_connector_shw = ui.shw;
 			UnitsData.ptr_connector_shw_org = ui.shw_org;
-			SDL_SetColorKey (UnitsData.ptr_connector_shw, SDL_SRCCOLORKEY, 0xFF00FF);
+			SDL_SetColorKey (UnitsData.ptr_connector_shw, SDL_TRUE, 0xFF00FF);
 		}
 		else if (b.ID == UnitsData.specialIDSmallBeton)
 		{
 			UnitsData.ptr_small_beton = ui.img;
 			UnitsData.ptr_small_beton_org = ui.img_org;
-			SDL_SetColorKey (UnitsData.ptr_small_beton, SDL_SRCCOLORKEY, 0xFF00FF);
+			SDL_SetColorKey (UnitsData.ptr_small_beton, SDL_TRUE, 0xFF00FF);
 		}
 
 		// Check if there is more than one frame
@@ -1680,12 +1680,12 @@
 		UnitsData.dirt_big = CloneSDLSurface (UnitsData.dirt_big_org);
 		LoadGraphicToSurface (UnitsData.dirt_big_shw_org, cSettings::getInstance().getBuildingsPath().c_str(), "dirt_big_shw.pcx");
 		UnitsData.dirt_big_shw = CloneSDLSurface (UnitsData.dirt_big_shw_org);
-		if (UnitsData.dirt_big_shw) SDL_SetAlpha (UnitsData.dirt_big_shw, SDL_SRCALPHA, 50);
+		if (UnitsData.dirt_big_shw) SDL_SetSurfaceAlphaMod (UnitsData.dirt_big_shw, 50);
 		LoadGraphicToSurface (UnitsData.dirt_small_org, cSettings::getInstance().getBuildingsPath().c_str(), "dirt_small.pcx");
 		UnitsData.dirt_small = CloneSDLSurface (UnitsData.dirt_small_org);
 		LoadGraphicToSurface (UnitsData.dirt_small_shw_org, cSettings::getInstance().getBuildingsPath().c_str(), "dirt_small_shw.pcx");
 		UnitsData.dirt_small_shw = CloneSDLSurface (UnitsData.dirt_small_shw_org);
-		if (UnitsData.dirt_small_shw) SDL_SetAlpha (UnitsData.dirt_small_shw, SDL_SRCALPHA, 50);
+		if (UnitsData.dirt_small_shw) SDL_SetSurfaceAlphaMod (UnitsData.dirt_small_shw, 50);
 	}
 	return 1;
 }
Index: log.cpp
===================================================================
--- log.cpp	(revision 3449)
+++ log.cpp	(working copy)
@@ -104,7 +104,7 @@
 		fprintf (stderr, "(EE): Couldn't open maxr.log!\n Please check file/directory permissions\n");
 		return false;
 	}
-	if (blocks < 0)
+	if (blocks <= 0)
 	{
 		fprintf (stderr, "(EE): Couldn't read maxr.log!\n Please check file/directory permissions\n");
 
@@ -173,9 +173,9 @@
 {
 	if (logfile)
 	{
-		int const wrote = SDL_RWwrite (logfile, str.c_str(), 1, (int) str.length());
+		const int wrote = SDL_RWwrite (logfile, str.c_str(), 1, (int) str.length());
 		std::cout << str;
-		if (wrote < 0)   //sanity check - was file writable?
+		if (wrote <= 0)   //sanity check - was file writable?
 		{
 			fprintf (stderr, "Couldn't write to maxr.log\nPlease check permissions for maxr.log\nLog message was:\n%s", str.c_str());
 			return -1;
Index: main.cpp
===================================================================
--- main.cpp	(revision 3442)
+++ main.cpp	(working copy)
@@ -27,7 +27,6 @@
 #include <SDL_thread.h>
 #include <SDL_net.h>
 #include <SDL_mixer.h>
-#include <SDL_getenv.h>
 
 #define __main__
 #include "main.h"
@@ -111,7 +110,7 @@
 
 	// load files
 	int loadingState = LOAD_GOING;
-	SDL_Thread* dataThread = SDL_CreateThread (LoadData, &loadingState);
+	SDL_Thread* dataThread = SDL_CreateThread (LoadData, "loadingData", &loadingState);
 
 	SDL_Event event;
 	while (loadingState != LOAD_FINISHED)
@@ -124,8 +123,12 @@
 		}
 		while (SDL_PollEvent (&event))
 		{
-			if (event.type == SDL_ACTIVEEVENT && !DEDICATED_SERVER)
-				SDL_UpdateRect (screen, 0, 0, 0, 0);
+			if (!DEDICATED_SERVER
+				&& event.type == SDL_WINDOWEVENT
+				&& event.window.event == SDL_WINDOWEVENT_EXPOSED)
+			{
+				Video.draw();
+			}
 		}
 		SDL_Delay (100);
 	}
@@ -172,7 +175,6 @@
 	else
 	{
 		Video.setResolution (Video.getResolutionX(), Video.getResolutionY(), true);
-		SDL_ShowCursor (0);
 		Video.clearBuffer();
 
 		mouse = new cMouse;
@@ -335,7 +337,7 @@
 	if (height > scr->h && dest) height = scr->h;
 
 	// generate new surface if necessary
-	if (dest == NULL) surface = SDL_CreateRGBSurface (scr->flags, width, height, scr->format->BitsPerPixel, scr->format->Rmask, scr->format->Gmask, scr->format->Bmask, scr->format->Amask);
+	if (dest == NULL) surface = SDL_CreateRGBSurface (0, width, height, scr->format->BitsPerPixel, scr->format->Rmask, scr->format->Gmask, scr->format->Bmask, scr->format->Amask);
 	else
 	{
 		// else set the size of the old one
@@ -421,8 +423,8 @@
 SDL_Surface* CreatePfeil (int p1x, int p1y, int p2x, int p2y, int p3x, int p3y, unsigned int color, int size)
 {
 	SDL_Surface* sf;
-	sf = SDL_CreateRGBSurface (Video.getSurfaceType() | SDL_SRCCOLORKEY, size, size, Video.getColDepth(), 0, 0, 0, 0);
-	SDL_SetColorKey (sf, SDL_SRCCOLORKEY, 0x00FF00FF);
+	sf = SDL_CreateRGBSurface (0, size, size, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_SetColorKey (sf, SDL_TRUE, 0x00FF00FF);
 	SDL_FillRect (sf, NULL, 0x00FF00FF);
 	SDL_LockSurface (sf);
 
@@ -974,8 +976,8 @@
 	if (!dst || !src) return;
 
 	//check surface formats
-	if (!dst->format->Amask) return;
-	if (src->format->Amask || ! (src->flags & SDL_SRCALPHA)) return;
+	if (!dst->format->Amask || src->format->Amask) return;
+	if (SDL_GetSurfaceAlphaMod(src, NULL) != 0) return;
 
 	if (srcrect == NULL)
 	{
@@ -1037,7 +1039,8 @@
 	if (SDL_MUSTLOCK (dst)) SDL_LockSurface (dst);
 
 	//setup needed variables
-	const Uint32 srcAlpha = src->format->alpha;
+	Uint8 srcAlpha = 0;
+	SDL_GetSurfaceAlphaMod (src, &srcAlpha);
 	const int srmask = src->format->Rmask;
 	const int sgmask = src->format->Gmask;
 	const int sbmask = src->format->Bmask;
@@ -1049,8 +1052,8 @@
 	const int gshift = src->format->Gshift - dst->format->Gshift;
 	const int bshift = src->format->Bshift - dst->format->Bshift;
 	const int ashift = dst->format->Ashift;
-	const Uint32 colorKey = src->format->colorkey;
-	const bool useColorKey = (src->flags & SDL_SRCCOLORKEY) != 0;
+	Uint32 colorKey = 0;
+	const bool useColorKey = SDL_GetColorKey (src, &colorKey) == 0;
 
 	Uint32* dstPixel = static_cast<Uint32*> (dst->pixels) + dstrect->x + dstrect->y * dst->w;
 	Uint32* srcPixel = static_cast<Uint32*> (src->pixels) + srcrect->x + srcrect->y * src->w;
@@ -1107,7 +1110,8 @@
 
 void blittAlphaSurface (SDL_Surface* src, SDL_Rect* srcrect, SDL_Surface* dst, SDL_Rect* dstrect)
 {
-	if (dst->format->Amask && (src->flags & SDL_SRCALPHA))
+	// TODO: [SDL2] special blitSurface seems useless.
+	if (dst->format->Amask && SDL_GetSurfaceAlphaMod(src, NULL) == 0)
 		blittPerSurfaceAlphaToAlphaChannel (src, srcrect, dst, dstrect);
 	else
 		SDL_BlitSurface (src, srcrect, dst, dstrect);
Index: map.cpp
===================================================================
--- map.cpp	(revision 3450)
+++ map.cpp	(working copy)
@@ -28,6 +28,14 @@
 #include "vehicles.h"
 #include "video.h"
 
+#if 1 // TODO: [SDL2]: SDL_SetColors
+inline void SDL_SetColors (SDL_Surface* surface, SDL_Color* colors, int index, int size)
+{
+	SDL_SetPaletteColors (surface->format->palette, colors, index, size);
+}
+#endif
+
+
 sTerrain::sTerrain() :
 	water (false),
 	coast (false),
@@ -250,6 +258,8 @@
 		palette_shw[i].r = (unsigned char) (palette[i].r * 0.6f);
 		palette_shw[i].g = (unsigned char) (palette[i].g * 0.6f);
 		palette_shw[i].b = (unsigned char) (palette[i].b * 0.6f);
+		palette[i].a = 255;
+		palette_shw[i].a = 255;
 	}
 
 	// Load necessary Terrain Graphics
@@ -314,13 +324,13 @@
 	return true;
 }
 
-/*static*/SDL_Surface* cStaticMap::loadTerrGraph (SDL_RWops* fpMapFile, int iGraphicsPos, SDL_Color* Palette, int iNum)
+/*static*/SDL_Surface* cStaticMap::loadTerrGraph (SDL_RWops* fpMapFile, int iGraphicsPos, const SDL_Color (&colors)[256], int iNum)
 {
 	// Create new surface and copy palette
-	AutoSurface surface (SDL_CreateRGBSurface (SDL_SWSURFACE, 64, 64, 8, 0, 0, 0, 0));
+	AutoSurface surface (SDL_CreateRGBSurface (0, 64, 64, 8, 0, 0, 0, 0));
 	surface->pitch = surface->w;
 
-	SDL_SetColors (surface, Palette, 0, 256);
+	SDL_SetPaletteColors (surface->format->palette, colors, 0, 256);
 
 	// Go to position of filedata
 	SDL_RWseek (fpMapFile, iGraphicsPos + 64 * 64 * (iNum), SEEK_SET);
@@ -353,7 +363,7 @@
 	SDL_RWseek (mapFile, 64 * 64 * sGraphCount, SEEK_CUR);
 	SDL_RWread (mapFile, &Palette, 3, 256);
 
-	AutoSurface mapSurface (SDL_CreateRGBSurface (SDL_SWSURFACE, size, size, 8, 0, 0, 0, 0));
+	AutoSurface mapSurface (SDL_CreateRGBSurface (0, size, size, 8, 0, 0, 0, 0));
 	mapSurface->pitch = mapSurface->w;
 
 	mapSurface->format->palette->ncolors = 256;
@@ -388,20 +398,20 @@
 	//This is needed to make sure, that the pixeldata is copied 1:1
 
 	//copy the normal terrains
-	terrains[iNum].sf_org = SDL_CreateRGBSurface (Video.getSurfaceType(), 64, 64, 8, 0, 0, 0, 0);
-	SDL_SetColors (terrains[iNum].sf_org, surface->format->palette->colors, 0, 256);
+	terrains[iNum].sf_org = SDL_CreateRGBSurface (0, 64, 64, 8, 0, 0, 0, 0);
+	SDL_SetPaletteColors (terrains[iNum].sf_org->format->palette, surface->format->palette->colors, 0, 256);
 	SDL_BlitSurface (surface, NULL, terrains[iNum].sf_org, NULL);
 
-	terrains[iNum].sf = SDL_CreateRGBSurface (Video.getSurfaceType(), 64, 64, 8, 0, 0, 0, 0);
-	SDL_SetColors (terrains[iNum].sf, surface->format->palette->colors, 0, 256);
+	terrains[iNum].sf = SDL_CreateRGBSurface (0, 64, 64, 8, 0, 0, 0, 0);
+	SDL_SetPaletteColors (terrains[iNum].sf->format->palette, surface->format->palette->colors, 0, 256);
 	SDL_BlitSurface (surface, NULL, terrains[iNum].sf, NULL);
 
 	//copy the terrains with fog
-	terrains[iNum].shw_org = SDL_CreateRGBSurface (Video.getSurfaceType(), 64, 64, 8, 0, 0, 0, 0);
+	terrains[iNum].shw_org = SDL_CreateRGBSurface (0, 64, 64, 8, 0, 0, 0, 0);
 	SDL_SetColors (terrains[iNum].shw_org, surface->format->palette->colors, 0, 256);
 	SDL_BlitSurface (surface, NULL, terrains[iNum].shw_org, NULL);
 
-	terrains[iNum].shw = SDL_CreateRGBSurface (Video.getSurfaceType(), 64, 64, 8, 0, 0, 0, 0);
+	terrains[iNum].shw = SDL_CreateRGBSurface (0, 64, 64, 8, 0, 0, 0, 0);
 	SDL_SetColors (terrains[iNum].shw, surface->format->palette->colors, 0, 256);
 	SDL_BlitSurface (surface, NULL, terrains[iNum].shw, NULL);
 
@@ -451,7 +461,7 @@
 
 SDL_Surface* cStaticMap::createBigSurface (int sizex, int sizey) const
 {
-	SDL_Surface* mapSurface = SDL_CreateRGBSurface (Video.getSurfaceType(), sizex, sizey, Video.getColDepth(), 0, 0, 0, 0);
+	SDL_Surface* mapSurface = SDL_CreateRGBSurface (0, sizex, sizey, Video.getColDepth(), 0, 0, 0, 0);
 
 	if (SDL_MUSTLOCK (mapSurface)) SDL_LockSurface (mapSurface);
 	for (int x = 0; x < mapSurface->w; ++x)
Index: map.h
===================================================================
--- map.h	(revision 3442)
+++ map.h	(working copy)
@@ -127,7 +127,7 @@
 	void scaleSurfaces (int pixelSize);
 	static SDL_Surface* loadMapPreview(const std::string& mapPath, int* mapSize = NULL);
 private:
-	static SDL_Surface* loadTerrGraph (SDL_RWops* fpMapFile, int iGraphicsPos, SDL_Color* Palette, int iNum);
+	static SDL_Surface* loadTerrGraph (SDL_RWops* fpMapFile, int iGraphicsPos, const SDL_Color (&colors)[256], int iNum);
 	void copySrfToTerData (SDL_Surface* surface, int iNum);
 private:
 	std::string filename;   // Name of the current map
Index: mapdownload.cpp
===================================================================
--- mapdownload.cpp	(revision 3450)
+++ mapdownload.cpp	(working copy)
@@ -269,7 +269,7 @@
 void cMapSender::runInThread()
 {
 	// the thread will quit, when it finished uploading the map
-	thread = SDL_CreateThread (mapSenderThreadFunction, this);
+	thread = SDL_CreateThread (mapSenderThreadFunction, "mapSender", this);
 }
 
 //------------------------------------------------------------------------------
